//FreeType 2 includes
#include <ft2build.h>
#include FT_FREETYPE_H
#include FT_ERRORS_H
#include FT_CACHE_H
#include FT_CACHE_IMAGE_H
#include FT_CACHE_SMALL_BITMAPS_H
#include FT_SYSTEM_H
#include <freetype/internal/ftobjs.h>

typedef struct SDL_GlyphCacheItem {
	void				*Next;

	int				Glyph_Index;
	FT_Bitmap			Bitmap;

	int				Bitmap_left;
	int				Bitmap_top;
	int				Advance_x;

	unsigned char			Bitmap_Data;
} SDL_GlyphCacheItem;

typedef struct SDL_FontFaceCacheItem
 {
	void			*Next;

	SDL_FontFaceDescription	FaceDescr;
	FT_Face				Face;
	SDL_GlyphCacheItem	*GlyphCache;

	//Additional font paramters - usable for style
	int			Bold_Offset;
	int			Underline_Height;

	int			Ascent;
	int			Descent;
	int			Height;
	int			LineSkip;

	int			Use_Kerning;
}
SDL_FontFaceCacheItem;

typedef struct SDL_FontChangeHist {
	void	*Next;
	Uint16	History[1];
}
SDL_FontChangeHist;

//Type definition of the load filter function
typedef SDL_RWops * (*SDL_FreeTypeLoad_Filter_t)(const char *Name);

//Actualize Param Font Face pointer - ONLY INTERNAL USE !!!
extern DECLSPEC int SDL_FreeTypeClearFontChangeHistory(SDL_FontParam *Param);
extern DECLSPEC int SDL_FreeTypeGetFontFace(SDL_FontParam *Param);

extern SDL_FontFaceCacheItem	*SDL_FaceCache;
extern FT_Library			SDL_FreeTypeLibrary;
extern SDL_Surface		*SDL_FreeTypeCharSurface;
extern SDL_FreeTypeLoad_Filter_t	SDL_FreeTypeLoad_Filter;
//--- Internal definitions ---

//Loading face into cache
FT_Face SDL_FreeTypeFaceLoad(SDL_RWops *RWops, int Index);

//Predefined file filter
SDL_RWops *SDL_FreeTypeFaceLoad_FileFilter(const char *Name);

//Freetype2 error checking
#define SDL_FreeTypeCheckError(x,y) if (x != 0) {SDL_FreeTypeError(x);y;}
void SDL_FreeTypeError(FT_Error error);
